/* version 3, up to 2., enjoy
 * VP
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct node
{
    int d;
    struct node*next ;
} Node ;
typedef Node * Node_ptr;
typedef Node * LinkedList;

typedef struct nodestr
{
    char * str;
    struct nodestr * next ;
} NodeStr ;
typedef NodeStr * NodeStr_ptr;
typedef NodeStr * LinkedListStr;

/* function prototypes */
Node_ptr createNode(int) ;
LinkedList prepend(LinkedList llst, Node_ptr node_ptr);
LinkedList append(LinkedList llst, Node_ptr node_ptr);
LinkedList appendrec(LinkedList llst, Node_ptr node_ptr);
void appendref(LinkedList * llst_ptr, Node_ptr node_ptr);
void report (LinkedList llst) ;
void print(LinkedList llst);
void printrec (LinkedList llst) ;
void invprintrec (LinkedList llst);
void invprintiter (LinkedList llst)  ;
void invprintiter2 (LinkedList llst)  ;
LinkedList insert(LinkedList y,int pos, Node_ptr node_ptr );
int getlength( LinkedList llst);
void printnodei(LinkedList llst, int i ) ;
int getlength2( LinkedList llst, int len);
int getlength3( LinkedList llst);
LinkedList linkedcopy(LinkedList llst) ;
LinkedList linkedcopy2(LinkedList llst);
LinkedList linkedcopyrec(LinkedList llst);
void deleteLinkedList(LinkedList llst) ;
void splitlistcopy(LinkedList mylst,
		LinkedList * oddlst_ptr,
		LinkedList * evenlst_ptr) ;
void splitlist(LinkedList mylst,
		LinkedList * oddlst_ptr,
		LinkedList * evenlst_ptr) ;
void multiplexcopy(LinkedList * mylst_ptr,
		LinkedList firstlist,
		LinkedList secondlist);
void multiplex(LinkedList * mylst_ptr,
			LinkedList firstlist,
			LinkedList secondlist);
LinkedListStr prependStr (LinkedListStr lst, NodeStr_ptr node );
void printStr(LinkedListStr lst);
NodeStr_ptr createNodeStr(char * str) ;
void deleteLinkedListStr(LinkedListStr llst);
LinkedListStr deepcopy (LinkedListStr srclist) ;
LinkedListStr deepcopyref (LinkedListStr srclist, LinkedListStr * destlist_ptr);
LinkedListStr shallowcopy(LinkedListStr srclist, LinkedListStr * destlist_ptr);
void shallowdeletenostr(LinkedListStr shallow) ;
/* */
int shouldremove(NodeStr_ptr node_ptr);
typedef int (*Fn)(NodeStr_ptr );
int filter (LinkedListStr * llst_ptr, Fn f);
LinkedListStr reverse (LinkedListStr llst_ptr );
void reverseref (LinkedListStr * llst_ptr );
int insert2sorted(LinkedListStr * llst_ptr,
        NodeStr_ptr nodestr_ptr) ;
int clear (LinkedListStr * llst_ptr) ;
int unique (LinkedListStr * llst_ptr) ;
LinkedListStr listunique(LinkedListStr llst) ;

typedef struct addrnode {
    NodeStr_ptr nodestr_ptr;
    struct addrnode * next ;
} AddressNode ;
typedef AddressNode * AddressList;
AddressList inlist(LinkedListStr llst, char * str);
void praddr(AddressNode * x, void **next) ;
void deleteAddressList(AddressList llst);

typedef void (*F)();
void printx(Node_ptr x, void **next);
void printy(NodeStr_ptr y, void **next);
void printAll ( void * lst, F );

int main ( ) {
    LinkedList linked = NULL ;
    LinkedList copylinked = NULL;
    LinkedList copylinked2 = NULL;
    LinkedList copylinked3 = NULL;
    LinkedListStr strlst = NULL;

    linked = prepend(linked, createNode(1));
    linked = prepend(linked, createNode(-1));
    report(linked) ;
    linked = append(linked, createNode(2));
    report(linked) ;
    /* by value */
    linked = appendrec(linked, createNode(3));
    report(linked) ;
    /* by reference */
    appendref( &linked, createNode(4));
    report(linked) ;
    print(linked);
    printrec(linked);
    invprintrec (linked);
    invprintiter (linked);
    invprintiter2(linked);
    printf("insert\n");
    linked = insert(linked , 0 , createNode(10)) ;
    print(linked);
    linked = insert(linked , 1 , createNode(11)) ;
    print(linked);
    printf("len2: %d\n", getlength2(linked, 0));
    printf("len3: %d\n", getlength3(linked));
    printf("COPY\n");
	copylinked = linkedcopy(linked);
	print(copylinked);
	printf("COPY 2\n");
	copylinked2 = linkedcopy2(linked);
	print(copylinked2);

	printf("COPY REC\n");
	copylinked3 = linkedcopyrec(linked);
	print(copylinked3);
	deleteLinkedList(copylinked3);
	deleteLinkedList(copylinked);

	{
	LinkedList oddlst = NULL;
    LinkedList evenlst = NULL;

	printf("SPLIT COPY ODD EVEN\n");
	splitlistcopy(linked, &oddlst, &evenlst) ;
	print(oddlst);
	print(evenlst);
	deleteLinkedList(oddlst);
	deleteLinkedList(evenlst);

	printf("SPLIT NO COPY ODD EVEN\n");
	splitlist(copylinked2, &oddlst, &evenlst) ;
	print(oddlst);
	print(evenlst);
	printf("explain the values of addresses by comparing to COPY 2 above\n");

	printf("MULTIPLEX COPY\n");
	multiplexcopy(&copylinked3, oddlst, evenlst);
	print(copylinked3);
	deleteLinkedList(copylinked3);

	printf("MULTIPLEX NO COPY\n");
	multiplex(&copylinked3, oddlst, evenlst);
	print(copylinked3);
	deleteLinkedList(copylinked3);
	}
	deleteLinkedList(linked);

	printf("STR LIST\n");
	strlst = NULL;
	strlst = prependStr(strlst, createNodeStr("world!"));
	strlst = prependStr(strlst, createNodeStr("Hello"));
	printStr(strlst);

	{
	LinkedListStr strlstcopy ;
	printf("DEEP COPY STR\n");
	strlstcopy = deepcopy (strlst) ;
	printStr(strlstcopy);
	deleteLinkedListStr(strlstcopy);
	}

	{
	LinkedListStr strlstcopy, strlstcopy2 ;
	printf("DEEP COPY STR REF\n");
	deepcopyref (strlst, &strlstcopy) ;
	printStr(strlstcopy);
	strlstcopy2 = deepcopyref (strlst, &strlstcopy2) ;
	printStr(strlstcopy2);
	deleteLinkedListStr(strlstcopy);
	deleteLinkedListStr(strlstcopy2);
	}

	{
	LinkedListStr strlstcopy, strlstcopy2 ;
	printf("SHALLOW COPY STR REF\n");
	printf("src\n");
	printStr(strlst);
	printf("copies\n");
	shallowcopy (strlst, &strlstcopy) ;
	printStr(strlstcopy);
	strlstcopy2 = shallowcopy (strlst, &strlstcopy2) ;
	printStr(strlstcopy2);
	printf("notice same addresses for strings\n");
	printf("change one to change all (has same length with prior string so no buffer overflow)\n");
	strcpy(strlstcopy2->str,"HELLO");
	printStr(strlstcopy);
	printStr(strlstcopy2);
	deleteLinkedListStr(strlstcopy);
	shallowdeletenostr(strlstcopy2); /* food for thought! */
	}

	shallowdeletenostr(strlst); /* food for thought! */


    { /* ex2.24- ex2.25 */
    LinkedListStr lst2filter = NULL;
    int deletednodes ;

    lst2filter = prependStr(lst2filter, createNodeStr("str13"));
    lst2filter = prependStr(lst2filter, createNodeStr("str124"));
    lst2filter = prependStr(lst2filter, createNodeStr("str1"));
    printf("before\n");
    printStr(lst2filter);
    deletednodes = filter( &lst2filter, shouldremove);
    printf("after deleting %d nodes\n", deletednodes);
    printStr(lst2filter);

    deleteLinkedListStr(lst2filter);
    }


    { /* ex2.26 */
    LinkedListStr lst2reverse = NULL, after;

    lst2reverse = prependStr(lst2reverse, createNodeStr("one"));
    lst2reverse = prependStr(lst2reverse, createNodeStr("two"));
    lst2reverse = prependStr(lst2reverse, createNodeStr("three"));
    printf("before\n");
    printStr(lst2reverse);
    after = reverse( lst2reverse);
    printf("after\n");
    printStr(after);
    printf("after by ref\n");
    reverseref(&after);
    printStr(after);
    deleteLinkedListStr(after);
    }

    { /* demo for ex2.27 */
        LinkedListStr sorted = NULL;
        sorted = prependStr(sorted, createNodeStr("ttt"));
        sorted = prependStr(sorted, createNodeStr("ccc"));
        printf("before\n");
        printStr(sorted);
        printf("after\n");
        insert2sorted(&sorted, createNodeStr("eee"));
        printStr(sorted);
        insert2sorted(&sorted, createNodeStr("bbb"));
        printStr(sorted);
        insert2sorted(&sorted, createNodeStr("zzz"));
        printStr(sorted);
        insert2sorted(&sorted, createNodeStr("ddd"));
        printStr(sorted);
        deleteLinkedListStr(sorted);
    }

    { /* demo for ex2.28 */
        NodeStr_ptr node1_ptr, node2_ptr, node3_ptr, node4_ptr;
        LinkedListStr lst2clear = NULL;
        char * test = malloc(5);

        strcpy(test,"TEST");
        node1_ptr = createNodeStr(""); free(node1_ptr->str);
        node2_ptr = createNodeStr("Hello");
        node3_ptr = createNodeStr(""); free(node3_ptr->str);
        node4_ptr = createNodeStr(""); free(node4_ptr->str);
        node1_ptr->str = test; /* address only, shallow point at same str */
        node3_ptr->str = test; /* address only, shallow point at same str */
        node4_ptr->str = test; /* address only, shallow point at same str */
        lst2clear = node1_ptr;
        lst2clear = prependStr(lst2clear, node2_ptr);
        lst2clear = prependStr(lst2clear, node3_ptr);
        lst2clear = prependStr(lst2clear, node4_ptr);
        printf("Before\n");
        printStr(lst2clear);
        printf("After\n");
        clear (&lst2clear);
        printStr(lst2clear);
        deleteLinkedListStr(lst2clear);
        /* test not explicitly freed as is deleted when deleting list */
    }

  { /* demo for ex2.29 */
        LinkedListStr lst2unique = NULL;

        lst2unique = prependStr(lst2unique, createNodeStr("one"));
        lst2unique = prependStr(lst2unique, createNodeStr("one"));
        lst2unique = prependStr(lst2unique, createNodeStr("two"));
        lst2unique = prependStr(lst2unique, createNodeStr("two"));
        lst2unique = prependStr(lst2unique, createNodeStr("two"));
        lst2unique = prependStr(lst2unique, createNodeStr("three"));
        printf("Before\n");
        printStr(lst2unique);
        printf("After\n");
        unique (&lst2unique);
        printStr(lst2unique);
        deleteLinkedListStr(lst2unique);
    }

    {
        /* demo for ex2.30 */
        LinkedListStr lst2unique = NULL, uniques = NULL;

        lst2unique = prependStr(lst2unique, createNodeStr("one"));
        lst2unique = prependStr(lst2unique, createNodeStr("one"));
        lst2unique = prependStr(lst2unique, createNodeStr("two"));
        lst2unique = prependStr(lst2unique, createNodeStr("two"));
        lst2unique = prependStr(lst2unique, createNodeStr("two"));
        lst2unique = prependStr(lst2unique, createNodeStr("three"));
        printf("Before\n");
        printStr(lst2unique);
        printf("Unique copy\n");
        uniques = listunique (lst2unique);
        printStr(uniques);
        deleteLinkedListStr(uniques);
        deleteLinkedListStr(lst2unique);
    }


    {
        /* demo for ex2.31 */
        LinkedListStr strlst = NULL;
        AddressList addrlst = NULL;
        strlst = prependStr(strlst, createNodeStr("one"));
        strlst = prependStr(strlst, createNodeStr("two"));
        strlst = prependStr(strlst, createNodeStr("two"));
        addrlst = inlist(strlst, "two");

        printAll(addrlst, praddr) ; /* using ex2.32... */

        deleteLinkedListStr(strlst);
        deleteAddressList(addrlst);
    }



    {
        /* demo for ex2.32 */

        LinkedListStr strlst = NULL;
        LinkedList dlst = NULL ;
        strlst = prependStr(strlst, createNodeStr("one"));
        strlst = prependStr(strlst, createNodeStr("two"));
        dlst = prepend(dlst, createNode(1));
        dlst = prepend(dlst, createNode(2));
        printf("printing various lists\n");
        printAll( strlst, printy);
        printAll( dlst, printx);
        deleteLinkedListStr(strlst);
        deleteLinkedList(dlst);
    }


	return 0 ;
}

void report (LinkedList llst)  {
    if (llst==NULL) { printf("\n"); return ;}
    printf("%d %p::", llst->d,  (void *) llst->next) ;
    report (llst->next);
    return ;
}


/* ex2.1 */
Node_ptr createNode(int d) {
    Node_ptr temp_ptr ;
    temp_ptr = malloc(sizeof (Node));
    temp_ptr -> d = d;
    temp_ptr -> next = NULL;
   return temp_ptr;
}

/* ex2.2 */
LinkedList prepend(LinkedList llst, Node_ptr node_ptr) {
    if (node_ptr == NULL) return llst;
    node_ptr -> next = llst;
    return node_ptr;
}

/* ex2.3 */
LinkedList append(LinkedList llst, Node_ptr node_ptr) {
   Node_ptr iter_ptr;
   if (llst==NULL) return node_ptr;
   if (node_ptr == NULL) return llst ;

   for (iter_ptr = llst; iter_ptr -> next != NULL ;
                iter_ptr = iter_ptr->next );
   /* iter_ptr points to last element in the linked list */
   iter_ptr -> next = node_ptr;

   return llst;
}

/* ex2.4 */
LinkedList appendrec(LinkedList llst, Node_ptr node_ptr) {
    if (node_ptr == NULL) return llst ;
    if (llst == NULL) return node_ptr ;
    llst->next = appendrec ( llst->next, node_ptr) ;
    return llst;
}

/* ex2.5 by reference and recursive */
void appendref(LinkedList * llst_ptr, Node_ptr node_ptr) {

    if (node_ptr == NULL) return ;

    /* *llst_ptr IS linked */
    if ( *llst_ptr == NULL)  {
            *llst_ptr = node_ptr;
            return ;
        }

    appendref ( & ((*llst_ptr)->next), node_ptr) ;

    return ;
}

/* ex2.6 */
void print(LinkedList llst) {
    printf("PRINT\n");
    for ( ; llst!=NULL; llst = llst->next ) {
       printf("%d %p::", llst->d,  (void *) llst->next) ;
    }
    printf("\n");
    return ;
}
/* ex2.7 */
void printrec (LinkedList llst)  {
    if (llst==NULL) { printf(" was PRINTREC\n"); return ;}
    printf("%d %p::", llst->d,  (void *) llst->next) ;
    printrec (llst->next);
    return ;
}

/* ex2.8 */
void invprintrec (LinkedList llst)  {
    if (llst==NULL) { printf("INVPRINTREC\n"); return ;}
    invprintrec (llst->next);
    printf("%d %p::", llst->d,  (void *) llst->next) ;
    return ;
}

/* ex2.9  */
void invprintiter (LinkedList llst)  {
    Node_ptr iter_ptr ;
    Node_ptr * arr_iter_ptr = NULL;
    int i = 0;
    printf("\nINVPRINTITER\n");
    if (llst==NULL) {  return ;}

    for (iter_ptr = llst; iter_ptr != NULL ;
                iter_ptr = iter_ptr->next ) {
    arr_iter_ptr = realloc( arr_iter_ptr, (i+1) * sizeof (Node_ptr) );
    arr_iter_ptr[i] = iter_ptr;
    i++; /* i contains current number of nodes */
    }

    for ( ; i>0; i--) {
        printf("%d %p::",
        arr_iter_ptr[i-1] -> d,
        (void *) arr_iter_ptr[i-1] -> next);
    }
    printf("\n");
    free(arr_iter_ptr);
    return ;
}

/* ex2.9 with (hidden) nested for loops*/

int getlength( LinkedList llst) {
    if (llst==NULL) return 0;
    return 1 + getlength(llst->next) ;
}

int getlength2( LinkedList llst, int len) {
    if (llst==NULL) return len;
    return getlength2(llst->next, len + 1) ;
}

int getlength3(LinkedList llst) {
	int len = 0;
	while (llst!=NULL) {
		len = len + 1;
		llst=llst->next;
	}
	return len;
}


/* print ith node of list */
void printnodei(LinkedList llst, int i ) {
    int j = 0;
    for ( ;llst!=NULL && j<i ; llst=llst->next) {
        j++;
    }
    if (llst==NULL) {printf("not enough nodes"); return ;}
    printf("%d %p (%d)::",llst -> d,(void *) llst -> next, j);
    return ;
}

void invprintiter2 (LinkedList llst)   {
    int count;
    int j;
    printf("\nINVPRINTITER2\n");
    count = getlength(llst);
    for (j = count-1; j>=0; j--) {
        printnodei(llst, j) ;
    }
    return ;
}

/* ex 2.10 */
LinkedList insert(LinkedList y,int pos, Node_ptr node_ptr ) {
    if (y==NULL && pos > 0 ) {printf(" not possible"); return y ;}
    if (node_ptr == NULL) { printf("empty node"); return y;}
    if (pos == 0 ) {
            node_ptr -> next = y;
            return node_ptr;
        }
    y->next = insert (y->next, pos - 1, node_ptr) ;
    return y ;
}
/* ex 2.11 */
Node_ptr nodecopy(Node_ptr node_ptr) {
    Node_ptr copy_ptr;
    copy_ptr = malloc(sizeof (Node)) ;
    copy_ptr->d = node_ptr ->d ;
    copy_ptr->next =NULL ;
    return copy_ptr;
}
/* can use createNode */
Node_ptr nodecopy2(Node_ptr node_ptr) {
   return createNode(node_ptr->d);
}
/* ex2.12 */
/* solution with append and create node */
LinkedList linkedcopy(LinkedList llst) {
	LinkedList copy  = NULL;

	while (llst!= NULL) {
		copy = append(copy, createNode(llst->d));
		llst = llst -> next;
	}

	return copy;
}
/* solution with createNode. Which one uses less steps? */
LinkedList linkedcopy2(LinkedList llst) {
	LinkedList copy  = NULL;
	Node_ptr copytail_ptr = NULL;

	while (llst != NULL) {
		if (copytail_ptr==NULL) {
			copytail_ptr = createNode(llst->d);
			copy = copytail_ptr;
		}
		else {
			copytail_ptr->next =createNode(llst->d);
			copytail_ptr = copytail_ptr->next;
		}
		llst = llst -> next;
	}
	return copy;
}

/* ex2.13 */
LinkedList linkedcopyrec(LinkedList llst) {
	LinkedList copy  ;
	if (llst==NULL) return NULL;
	copy = createNode(llst->d);
	copy->next = linkedcopyrec(llst->next) ;
	return copy;
}

/* ex2.14 */
void deleteLinkedList(LinkedList llst) {
	if (llst==NULL) return ;
	deleteLinkedList(llst->next);
	free(llst);
	return ;
}

/* ex2.15 */
/* solution with append and createNode */
void splitlistcopy(LinkedList mylst,
		LinkedList * oddlst_ptr,
		LinkedList * evenlst_ptr) {
	*oddlst_ptr = NULL;
	*evenlst_ptr = NULL;
	while (mylst != NULL) {
		if (mylst->d % 2 == 0) {
			*evenlst_ptr = append (*evenlst_ptr, createNode(mylst->d));
		}
		else {
			*oddlst_ptr = append (*oddlst_ptr, createNode(mylst->d));
		}
		mylst = mylst -> next ;
	}
	return ;
}
/* can you write a solution which requires less steps ? */

/* ex2.16 (notice that no new node is created!) */
/* solution with append */
void splitlist(LinkedList mylst,
		LinkedList * oddlst_ptr,
		LinkedList * evenlst_ptr) {
	*oddlst_ptr = NULL;
	*evenlst_ptr = NULL;
	while (mylst != NULL) {
		Node_ptr temp = mylst->next; /* copy address of next */
		mylst->next = NULL ; 		/* NULL next guarantee termination
									   of partial lists */
		if (mylst -> d % 2 == 0)
			*evenlst_ptr  = append(*evenlst_ptr, mylst);
		else
			*oddlst_ptr  = append(*oddlst_ptr, mylst);
		mylst = temp;
	}

	return ;
}

/* ex2.17 use createNode and append */
void multiplexcopy(LinkedList * mylst_ptr,
		LinkedList firstlist,
		LinkedList secondlist) {

	*mylst_ptr = NULL;
	while (firstlist != NULL || secondlist != NULL) {
		if (firstlist!=NULL) {
			*mylst_ptr = append(*mylst_ptr, createNode(firstlist->d));
			firstlist = firstlist -> next;
		}
		if (secondlist!=NULL) {
			*mylst_ptr = append(*mylst_ptr, createNode(secondlist->d));
			secondlist = secondlist -> next;
		}
	}
	return ;
}

/* ex2.18 */
void multiplex(LinkedList * mylst_ptr,
			LinkedList firstlist,
			LinkedList secondlist) {
	*mylst_ptr = NULL;
	while (firstlist != NULL || secondlist != NULL) {
		if (firstlist!=NULL) {
			Node_ptr firsttemp = firstlist->next ;
			firstlist -> next = NULL;
			*mylst_ptr = append(*mylst_ptr, firstlist);
			firstlist = firsttemp ;
		}
		if (secondlist!=NULL) {
			Node_ptr secondtemp = secondlist->next;
			secondlist->next = NULL;
			*mylst_ptr = append(*mylst_ptr, secondlist);
			secondlist = secondtemp;
		}
	}
	return ;
}

/* ex2.19 */
NodeStr_ptr createNodeStr(char * str) {
    NodeStr_ptr temp_ptr ;
    temp_ptr = malloc(sizeof (NodeStr));
    temp_ptr -> str = malloc((strlen(str)+1)*sizeof(char));
    strcpy(temp_ptr -> str, str);
    temp_ptr -> next = NULL;
   return temp_ptr;
}

/* helper functions for LinkedListStr : prependStr, printStr */
LinkedListStr prependStr (LinkedListStr lst, NodeStr_ptr node ) {
	if (node == NULL) return lst;
	node->next = lst;
	return node;
}
void printStr(LinkedListStr lst) {
	if (lst == NULL) {printf("\n"); return ;}
	printf("%s (node at %p, str at %p)::", lst->str, (void *) lst, (void *) lst->str);
	printStr(lst->next);
	return ;
}

/* ex2.20: iterative implementation (as requested) */

void deleteLinkedListStr(LinkedListStr llst) {
	while (llst!=NULL) {
		LinkedListStr temp = llst->next;
		free(llst->str);
		free(llst);
		llst = temp;
	}
	return ;
}

/* a recursive implementation */
void deleteLinkedListStrRec(LinkedListStr llst) {
	if (llst==NULL) return ;
	deleteLinkedListStrRec(llst->next) ;
	free(llst->str);
	free(llst);
	return ;
}

/* ex2.21 */

LinkedListStr deepcopy (LinkedListStr srclist) {
	LinkedListStr copy = NULL;
	while (srclist != NULL) {
		NodeStr_ptr temp = malloc(sizeof (NodeStr));
		if (temp==NULL) return NULL;
		temp->str = malloc((strlen(srclist->str)+1)*sizeof(char));
		if (temp->str == NULL) return NULL;
		strcpy(temp->str, srclist->str);
		temp->next = NULL;
		if (copy == NULL) {
			copy = temp;
		} else
		{
			copy->next = temp;
		}
		srclist = srclist->next;
	}
	return copy;
}

/* ex2.22 */
LinkedListStr deepcopyref (LinkedListStr srclist, LinkedListStr * destlist_ptr) {
	*destlist_ptr = NULL;
	while (srclist != NULL) {
		NodeStr_ptr temp = malloc(sizeof (NodeStr));
		if (temp==NULL) { *destlist_ptr = NULL; return NULL; }
		temp->str = malloc((strlen(srclist->str)+1)*sizeof(char));
		if (temp->str == NULL) { *destlist_ptr = NULL; return NULL;}
		strcpy(temp->str, srclist->str);
		temp->next = NULL;
		if (*destlist_ptr == NULL) {
			*destlist_ptr = temp;
		} else
		{
			(*destlist_ptr) ->next = temp;
		}
		srclist = srclist->next;
	}
	return *destlist_ptr;
}

/* ex2.23 */
LinkedListStr shallowcopy(LinkedListStr srclist, LinkedListStr * destlist_ptr) {
	*destlist_ptr = NULL;
	while (srclist != NULL) {
		NodeStr_ptr temp = malloc(sizeof (NodeStr));
		if (temp==NULL) { *destlist_ptr = NULL; return NULL; }
		temp->str = srclist->str ; /* copies address only, does not copy string */
		temp->next = NULL;
		if (*destlist_ptr == NULL) {
			*destlist_ptr = temp;
		} else
		{
			(*destlist_ptr) ->next = temp;
		}
		srclist = srclist->next;
	}
	return *destlist_ptr;
}

/* helper shallow delete (to avoid double freeing str points
   only to be called on shallow copies with already freed strings
 */
void shallowdeletenostr(LinkedListStr shallow) {
	while (shallow!=NULL) {
		LinkedListStr temp = shallow->next;
		free(shallow);
		shallow = temp;
	}
	return ;
}

/* ex2.24  -  ex2.25*/
int shouldremove(NodeStr_ptr node_ptr) {
    return  strlen(node_ptr->str) % 2 == 0 ;
}

int filter (LinkedListStr * llst_ptr, Fn f) {
    int count = 0 ;
    NodeStr_ptr iter_ptr = *llst_ptr;
    NodeStr_ptr previous_node_ptr = NULL;

    while ( iter_ptr!= NULL ) {
        if (f(iter_ptr)) { /* delete node */
            if (previous_node_ptr == NULL) {
                *llst_ptr = iter_ptr->next ;
                }
            else {
                previous_node_ptr->next = iter_ptr->next;
            }
            free(iter_ptr->str) ;
            free(iter_ptr);
            count++;
            if (previous_node_ptr == NULL)
                iter_ptr = *llst_ptr;
            else
                iter_ptr = previous_node_ptr->next;
        }
        else { /* do not delete node */
            if (previous_node_ptr != NULL) {
                previous_node_ptr = iter_ptr;
                iter_ptr = previous_node_ptr -> next;
            }
            else { /* at least one node exists, hence (*llst_ptr) != NULL*/
                previous_node_ptr = *llst_ptr;
                iter_ptr = (*llst_ptr)->next;
            }
        }
    }
    return count;
}

/* ex2.26 */
/* reverse using by reference and recursion */
void reverseref (LinkedListStr * llst_ptr ) {
    LinkedListStr  remainder ;
    if (*llst_ptr == NULL ) return  ; /* no nodes */
    if ((*llst_ptr)->next == NULL )  return ; /* only one node */
    remainder = (*llst_ptr) -> next;
    reverseref( & remainder) ;
    (*llst_ptr)->next->next = *llst_ptr ;
    (*llst_ptr)->next = NULL ;
    *llst_ptr = remainder;
    return  ;
}

/* also a by value solution */
LinkedListStr reverse (LinkedListStr llst ) {
    LinkedListStr remainder;
    if (llst == NULL ) return  llst; /* no nodes */
    if (llst->next == NULL )  return llst; /* only one node */
    remainder = reverse( llst->next) ;
    llst->next->next = llst;
    llst->next = NULL ;
    return remainder ;
}

/* ex2.27 */
int insert2sorted(LinkedListStr * llst_ptr,
        NodeStr_ptr nodestr_ptr) {
     NodeStr_ptr iter_ptr = *llst_ptr;

     if ( nodestr_ptr == NULL)  return 0; /* no node to insert */
     if (*llst_ptr == NULL) {            /* insert as first in empty list */
        *llst_ptr = nodestr_ptr;
        return 1;
     }
     if (strcmp(nodestr_ptr->str, (*llst_ptr)->str)<0) { /* insert as first in non-empty list */
        nodestr_ptr->next = *llst_ptr;                   /* could combine with empty list case */
        *llst_ptr = nodestr_ptr;
        return 1;
     }
     while (iter_ptr->next != NULL) {
        if (strcmp(nodestr_ptr->str, iter_ptr->next->str)<0) { /* insert criterion */
            nodestr_ptr->next = iter_ptr->next;
            iter_ptr->next = nodestr_ptr;
            return 1;   /* breaks loop, returns from function */
        }
        iter_ptr = iter_ptr -> next;
     }
     /* if has reached last node. i.e, iter_ptr->next==NULL, append  */
     iter_ptr->next = nodestr_ptr;
     return 1;
}

/* ex2.28 */
int clear (LinkedListStr * llst_ptr) {
    int count = 0;
    NodeStr_ptr iter1_ptr, iter2_ptr, previous_ptr ;
    if (*llst_ptr == NULL) return 0;

    for(iter1_ptr = *llst_ptr ; iter1_ptr!=NULL && iter1_ptr->next!=NULL; iter1_ptr = iter1_ptr ->next ) {
            previous_ptr = iter1_ptr;
            for(iter2_ptr = iter1_ptr->next; iter2_ptr!= NULL; iter2_ptr = iter2_ptr ->next ) {
                if(iter1_ptr->str == iter2_ptr->str) { /* compares addresses, not strings */
                    previous_ptr->next = iter2_ptr->next ;
                    free(iter2_ptr); /* note that str should not be freed */
                    count ++;
                    iter2_ptr = previous_ptr;
                }
                else
                    previous_ptr = iter2_ptr;
            }
            }
    return count;
}

/* ex2.29 */
int unique (LinkedListStr * llst_ptr) {
    int count = 0;
    NodeStr_ptr iter1_ptr, iter2_ptr, previous_ptr ;
    if (*llst_ptr == NULL) return 0;

    for(iter1_ptr = *llst_ptr ; iter1_ptr!=NULL && iter1_ptr->next!=NULL; iter1_ptr = iter1_ptr ->next ) {
            previous_ptr = iter1_ptr;
            for(iter2_ptr = iter1_ptr->next; iter2_ptr!= NULL; iter2_ptr = iter2_ptr ->next ) {
                if(strcmp(iter1_ptr->str , iter2_ptr->str)==0) { /* compares strings */
                    previous_ptr->next = iter2_ptr->next ;
                    free(iter2_ptr->str); /* assumes that strings are in different memory locations */
                    free(iter2_ptr); /* note that str should not be freed */
                    count ++;
                    iter2_ptr = previous_ptr;
                }
                else
                    previous_ptr = iter2_ptr;
            }
            }
    return count;
}

/* ex2.30 */
LinkedListStr listunique(LinkedListStr llst) {
    LinkedListStr lstunique = NULL;
    NodeStr_ptr iter_ptr, tail_ptr = NULL;
    if (llst == NULL) return NULL;
    if (lstunique ==NULL) {
            lstunique = createNodeStr(llst->str) ;
        }
    llst = llst->next ;
    while (llst!=NULL) {
        for (iter_ptr = lstunique; iter_ptr != NULL; iter_ptr = iter_ptr->next) {
            if (strcmp(iter_ptr->str, llst->str)==0)  break;
            tail_ptr = iter_ptr;
        }
        if (iter_ptr ==NULL) tail_ptr->next = createNodeStr(llst->str);
        llst = llst->next ;
    }
    return lstunique;
}


/* ex2.31 */
AddressNode * createaddr(NodeStr_ptr x ) {
    AddressNode * addrnode_ptr ;
    addrnode_ptr = malloc(sizeof(AddressNode)) ;
    addrnode_ptr -> nodestr_ptr = x ;
    addrnode_ptr -> next = NULL;
    return addrnode_ptr;
}

AddressList prependAddr(AddressList lst, AddressNode * node_ptr) {
    node_ptr -> next = lst;
    return node_ptr ;
}

void deleteAddressList(AddressList llst) {
	if (llst==NULL) return ;
	deleteAddressList(llst->next) ;
	free(llst);
	return ;
}
AddressList inlist(LinkedListStr llst, char * str) {
    AddressList addrlst = NULL;

    for (;llst!=NULL; llst=llst->next)
        if(strcmp(llst->str, str)==0)
            addrlst = prependAddr(addrlst, createaddr(llst));

    return addrlst;
}

void praddr(AddressNode * x, void **next) {
    printf(" %p (%s)## ", (void *) x->nodestr_ptr, (x->nodestr_ptr)->str);
    *next = x->next ;
    return ;
}

/* ex2.32 */
void printx(Node_ptr x, void **next) {
    printf(" %d ## ", x->d);
    *next = x->next ;
    return ;
}
void printy(NodeStr_ptr y, void **next) {
    printf(" %s ## ", y->str);
    *next = y->next ;
    return ;
}
void printAll ( void * lst, F pr) {
    void * next;
    if (lst==NULL) {printf("\n"); return ;}
    pr(lst, &next);
    printAll(next, pr);
    return ;
}

